.686p                     ; create 32 bit code
.model flat, stdcall      ; 32 bit memory model
option casemap :none      ; case sensitive
.xmm

include    \masm32\include\windows.inc
include    \masm32\include\user32.inc
include    \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

.data
   pbcd      dt ?
             db  6 dup (0)
   first9    db 32 dup (0)
   last9     db 32 dup (0)

   ii        dd 1,2,4,8,16,32,64,128,256,512,0,0ffh,0ffh,0ffh,0ffh,0 ; 1022 for pandigital

   aa        real10   0.0
             db    6  dup (0)
   bb        real10   1.0
             db    6  dup (0)
   zz        real10   0.0
             db    6  dup (0)
   yy        real10   1.0
             db    6  dup (0)
   cc        real10   7.0
             db    6  dup (0)
   tw        real10   1.0e20
             db    6  dup (0)
   te        real10   10.0
             db    6  dup (0)
   hu        real10   100.0
             db    6  dup (0)
   ei        real10   1.0e18
             db    6  dup (0)
   ni        real10   1.0e9
             db    6  dup (0)

   fib       dd 0
   i         dd 0

   bothends  dd 0
   first9zero  dd 0

   szFirst9    db "The first 9(+) digits of the kth fibonacci number are ", 0

   szLast9     db "The last  9    digits of the kth fibonacci number are ", 0


; 


.code

start:
   finit

   fldz
   fstp  aa
   fldz
   fstp  zz
   mov   fib, 0

   fld1
   fstp  bb
   fld1
   fstp  yy
   inc   fib

   mov   i, 0

   .repeat
      fld  bb
      fld  aa
      faddp st(1), st     ; st1 = st1 + st  pop st
      fstp aa

      fld  yy
      fld  zz
      faddp st(1), st     ; st1 = st1 + st  pop st
      fstp zz

      fld  bb  ; swap aa bb  pop both
      fld  aa
      fstp bb
      fstp aa

      fld  yy  ; swap zz yy  pop both
      fld  zz
      fstp yy
      fstp zz

      nop
      nop

      fld  zz       ; if zz >= ni
      fld  ni
      fcompp
      fstsw ax
      sahf
      ja @F        ; no  skip
         fld   zz   ; yes zz - ni
         fld   ni
         fsubp st(1),st(0)
         fstp  zz
         fwait
@@:
      fld  yy       ; if yy >= ni
      fld  ni
      fcompp
      fstsw ax
      sahf
      ja @F        ; no  skip
         fld   yy   ; yes yy - ni
         fld   ni
         fsubp st(1),st(0)
         fstp  yy
         fwait
@@:
      inc  i
      .if i >= 5
         mov  i, 0
         fld  aa
         fld  tw
         fcompp            ;  if aa > tw
         fstsw ax                              
         sahf
         jnb  @F           ;  no jump past  
           fld    aa       ;    aa
           fld    hu       ;    hu
           fdivp  st(1),st ;    aa / hu
           fstp   aa       ;    aa = 
           fwait

           fld    bb       ;    bb
           fld    hu       ;    hu
           fdivp  st(1),st ;    bb / hu
           fstp   bb       ;    bb =
           fwait
      .endif
@@:
      inc fib
   .until fib == 329468


   fld  bb  ; swap aa bb  pop both
   fld  aa
   fstp bb
   fstp aa

   fld  yy  ; swap zz yy  pop both
   fld  zz
   fstp yy
   fstp zz

@@:
   fld  aa
   fld  ei           ;  ei se
   fcompp            ;  if aa > ei
   fstsw ax                              
   sahf
   jnb  @F           ;  no jump past  
     fld  aa         ;  aa
     fld  te         ;  10.0
     fdivp st(1),st  ;  a / te
     fstp aa         ;  aa :=
     fwait
     jmp @B
@@:
   fld   aa
   fbstp pbcd       ; store Packed BCD 9 bytes lo -> hi, within a byte hi, lo nibble first, second
   fwait

   mov eax, 0
   mov ecx, 8
   mov edx, 0
@@:
   mov al, byte ptr pbcd[ecx]
   shl eax, 4
   or  ah,  30h
   mov first9[edx+0], ah
   mov ah,  0
   shr eax, 4
   or  al,  30h
   mov first9[edx+1], al
   inc edx
   inc edx
   jecxz @F
   dec   ecx
   jmp   @B
@@:

   fld   zz
   fbstp pbcd      ; store Packed BCD 9 bytes lo -> hi, within a byte hi, lo nibble first, second
   fwait

   mov eax, 0
   mov ecx, 8
   mov edx, 0
@@:
   mov al, byte ptr pbcd[ecx]
   shl eax, 4
   or  ah,  30h
   mov last9[edx+0], ah
   mov ah,  0
   shr eax, 4
   or  al,  30h
   mov last9[edx+1], al
   inc edx
   inc edx
   jecxz @F
   dec   ecx
   jmp   @B
@@:

   invoke MessageBox,NULL,ADDR first9,ADDR szFirst9,MB_OK

   mov ecx, offset last9
   add ecx, 9
   invoke MessageBox,NULL,ecx,ADDR szLast9,MB_OK

   invoke  ExitProcess, 0

end start